//
//  oglView.m
//  OGL
//
//  Created by Robert on 2/4/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "oglView.h"
#import <GLUT/glut.h>

@implementation oglView

- (id)initWithFrame:(NSRect)frameRect
        pixelFormat:(NSOpenGLPixelFormat *)format  {
    
    self = [super initWithFrame:frameRect pixelFormat:format];
    [self initOpenGL];
    return self;
}

- (id)initWithCoder:(NSCoder *)coder {
    self = [super initWithCoder: coder];
    [self initOpenGL];
    return self;
}

- (void)initOpenGL {
    NSOpenGLContext *glcontext;
    glcontext = [self openGLContext];
    [glcontext makeCurrentContext];
    
	glClearColor(0.1, 0.1, 0.1, 0.0);			// background color is dark gray
	glClear(GL_COLOR_BUFFER_BIT);				// clear the view
	glOrtho(0.0, 400, 0.0, 400, -1.0, 1.0);		// setup our 400x400 coords
}

- (void)drawRect:(NSRect)dirtyRect {
    NSLog(@"drawRect");

	glClear(GL_COLOR_BUFFER_BIT);				// erase the screen
   
	glMatrixMode(GL_MODELVIEW);	// use model matrix
	glLoadIdentity();			// reset matrix
	glOrtho(0.0, 400.0, 0.0, 400.0, -1.0, 1.0);	// we reset, so setup coords again	    

	glTranslatef(200, 200, 0);		// move to where we want to draw the triangle
	
	glBegin(GL_TRIANGLES);
        glColor3f(1.0f,0.0f,0.0f);
        glVertex3i(0, -100, 0);
        glColor3f(0.0f,1.0f,0.0f);
        glVertex3i(100, 100, 0);
        glColor3f(0.0f,0.0f,1.0f);
        glVertex3i(-100, 100, 0);
	glEnd();
    
    glFinish();
}

@end
